<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Learner.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">Learner.java</span></div><h1>Learner.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.zookeeper.server.quorum;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.IOException;
import java.net.ConnectException;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.nio.ByteBuffer;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map.Entry;
import java.util.concurrent.ConcurrentHashMap;

import org.apache.jute.BinaryInputArchive;
import org.apache.jute.BinaryOutputArchive;
import org.apache.jute.InputArchive;
import org.apache.jute.OutputArchive;
import org.apache.jute.Record;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.server.Request;
import org.apache.zookeeper.server.ServerCnxn;
import org.apache.zookeeper.server.ZooTrace;
import org.apache.zookeeper.server.quorum.QuorumPeer.QuorumServer;
import org.apache.zookeeper.server.util.SerializeUtils;
import org.apache.zookeeper.server.util.ZxidUtils;
import org.apache.zookeeper.txn.TxnHeader;

/**
 * This class is the superclass of two of the three main actors in a ZK
 * ensemble: Followers and Observers. Both Followers and Observers share 
 * a good deal of code which is moved into Peer to avoid duplication. 
 */
<span class="fc" id="L57">public class Learner {       </span>
<span class="fc" id="L58">    static class PacketInFlight {</span>
        TxnHeader hdr;
        Record rec;
    }
    QuorumPeer self;
    LearnerZooKeeperServer zk;
    
    protected BufferedOutputStream bufferedOutput;
    
    protected Socket sock;
    
    /**
     * Socket getter
     * @return 
     */
    public Socket getSocket() {
<span class="nc" id="L74">        return sock;</span>
    }
    
    protected InputArchive leaderIs;
    protected OutputArchive leaderOs;  
    /** the protocol version of the leader */
<span class="fc" id="L80">    protected int leaderProtocolVersion = 0x01;</span>
    
<span class="fc" id="L82">    protected static final Logger LOG = LoggerFactory.getLogger(Learner.class);</span>

<span class="fc" id="L84">    static final private boolean nodelay = System.getProperty(&quot;follower.nodelay&quot;, &quot;true&quot;).equals(&quot;true&quot;);</span>
    static {
<span class="fc" id="L86">        LOG.info(&quot;TCP NoDelay set to: &quot; + nodelay);</span>
<span class="fc" id="L87">    }   </span>
    
<span class="fc" id="L89">    final ConcurrentHashMap&lt;Long, ServerCnxn&gt; pendingRevalidations =</span>
        new ConcurrentHashMap&lt;Long, ServerCnxn&gt;();
    
    public int getPendingRevalidationsCount() {
<span class="nc" id="L93">        return pendingRevalidations.size();</span>
    }
    
    /**
     * validate a session for a client
     *
     * @param clientId
     *                the client to be revalidated
     * @param timeout
     *                the timeout for which the session is valid
     * @return
     * @throws IOException
     */
    void validateSession(ServerCnxn cnxn, long clientId, int timeout)
            throws IOException {
<span class="fc" id="L108">        LOG.info(&quot;Revalidating client: 0x&quot; + Long.toHexString(clientId));</span>
<span class="fc" id="L109">        ByteArrayOutputStream baos = new ByteArrayOutputStream();</span>
<span class="fc" id="L110">        DataOutputStream dos = new DataOutputStream(baos);</span>
<span class="fc" id="L111">        dos.writeLong(clientId);</span>
<span class="fc" id="L112">        dos.writeInt(timeout);</span>
<span class="fc" id="L113">        dos.close();</span>
<span class="fc" id="L114">        QuorumPacket qp = new QuorumPacket(Leader.REVALIDATE, -1, baos</span>
<span class="fc" id="L115">                .toByteArray(), null);</span>
<span class="fc" id="L116">        pendingRevalidations.put(clientId, cnxn);</span>
<span class="pc bpc" id="L117" title="1 of 2 branches missed.">        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L118">            ZooTrace.logTraceMessage(LOG,</span>
                                     ZooTrace.SESSION_TRACE_MASK,
                                     &quot;To validate session 0x&quot;
<span class="nc" id="L121">                                     + Long.toHexString(clientId));</span>
        }
<span class="fc" id="L123">        writePacket(qp, true);</span>
<span class="fc" id="L124">    }     </span>
    
    /**
     * write a packet to the leader
     *
     * @param pp
     *                the proposal packet to be sent to the leader
     * @throws IOException
     */
    void writePacket(QuorumPacket pp, boolean flush) throws IOException {
<span class="fc" id="L134">        synchronized (leaderOs) {</span>
<span class="fc bfc" id="L135" title="All 2 branches covered.">            if (pp != null) {</span>
<span class="fc" id="L136">                leaderOs.writeRecord(pp, &quot;packet&quot;);</span>
            }
<span class="fc bfc" id="L138" title="All 2 branches covered.">            if (flush) {</span>
<span class="fc" id="L139">                bufferedOutput.flush();</span>
            }
<span class="fc" id="L141">        }</span>
<span class="fc" id="L142">    }</span>

    /**
     * read a packet from the leader
     *
     * @param pp
     *                the packet to be instantiated
     * @throws IOException
     */
    void readPacket(QuorumPacket pp) throws IOException {
<span class="fc" id="L152">        synchronized (leaderIs) {</span>
<span class="fc" id="L153">            leaderIs.readRecord(pp, &quot;packet&quot;);</span>
<span class="fc" id="L154">        }</span>
<span class="fc" id="L155">        long traceMask = ZooTrace.SERVER_PACKET_TRACE_MASK;</span>
<span class="fc bfc" id="L156" title="All 2 branches covered.">        if (pp.getType() == Leader.PING) {</span>
<span class="fc" id="L157">            traceMask = ZooTrace.SERVER_PING_TRACE_MASK;</span>
        }
<span class="pc bpc" id="L159" title="1 of 2 branches missed.">        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L160">            ZooTrace.logQuorumPacket(LOG, traceMask, 'i', pp);</span>
        }
<span class="fc" id="L162">    }</span>
    
    /**
     * send a request packet to the leader
     *
     * @param request
     *                the request from the client
     * @throws IOException
     */
    void request(Request request) throws IOException {
<span class="fc" id="L172">        ByteArrayOutputStream baos = new ByteArrayOutputStream();</span>
<span class="fc" id="L173">        DataOutputStream oa = new DataOutputStream(baos);</span>
<span class="fc" id="L174">        oa.writeLong(request.sessionId);</span>
<span class="fc" id="L175">        oa.writeInt(request.cxid);</span>
<span class="fc" id="L176">        oa.writeInt(request.type);</span>
<span class="pc bpc" id="L177" title="1 of 2 branches missed.">        if (request.request != null) {</span>
<span class="fc" id="L178">            request.request.rewind();</span>
<span class="fc" id="L179">            int len = request.request.remaining();</span>
<span class="fc" id="L180">            byte b[] = new byte[len];</span>
<span class="fc" id="L181">            request.request.get(b);</span>
<span class="fc" id="L182">            request.request.rewind();</span>
<span class="fc" id="L183">            oa.write(b);</span>
        }
<span class="fc" id="L185">        oa.close();</span>
<span class="fc" id="L186">        QuorumPacket qp = new QuorumPacket(Leader.REQUEST, -1, baos</span>
<span class="fc" id="L187">                .toByteArray(), request.authInfo);</span>
<span class="fc" id="L188">        writePacket(qp, true);</span>
<span class="fc" id="L189">    }</span>
    
    /**
     * Returns the address of the node we think is the leader.
     */
    protected InetSocketAddress findLeader() {
<span class="fc" id="L195">        InetSocketAddress addr = null;</span>
        // Find the leader by id
<span class="fc" id="L197">        Vote current = self.getCurrentVote();</span>
<span class="pc bpc" id="L198" title="1 of 2 branches missed.">        for (QuorumServer s : self.getView().values()) {</span>
<span class="fc bfc" id="L199" title="All 2 branches covered.">            if (s.id == current.getId()) {</span>
                // Ensure we have the leader's correct IP address before
                // attempting to connect.
<span class="fc" id="L202">                s.recreateSocketAddresses();</span>
<span class="fc" id="L203">                addr = s.addr;</span>
<span class="fc" id="L204">                break;</span>
            }
<span class="fc" id="L206">        }</span>
<span class="pc bpc" id="L207" title="1 of 2 branches missed.">        if (addr == null) {</span>
<span class="nc" id="L208">            LOG.warn(&quot;Couldn't find the leader with id = &quot;</span>
<span class="nc" id="L209">                    + current.getId());</span>
        }
<span class="fc" id="L211">        return addr;</span>
    }
    
    /**
     * Establish a connection with the Leader found by findLeader. Retries
     * 5 times before giving up. 
     * @param addr - the address of the Leader to connect to.
     * @throws IOException - if the socket connection fails on the 5th attempt
     * @throws ConnectException
     * @throws InterruptedException
     */
    protected void connectToLeader(InetSocketAddress addr) 
    throws IOException, ConnectException, InterruptedException {
<span class="fc" id="L224">        sock = new Socket();        </span>
<span class="fc" id="L225">        sock.setSoTimeout(self.tickTime * self.initLimit);</span>
<span class="pc bpc" id="L226" title="1 of 2 branches missed.">        for (int tries = 0; tries &lt; 5; tries++) {</span>
            try {
<span class="fc" id="L228">                sock.connect(addr, self.tickTime * self.syncLimit);</span>
<span class="fc" id="L229">                sock.setTcpNoDelay(nodelay);</span>
<span class="fc" id="L230">                break;</span>
<span class="fc" id="L231">            } catch (IOException e) {</span>
<span class="pc bpc" id="L232" title="1 of 2 branches missed.">                if (tries == 4) {</span>
<span class="nc" id="L233">                    LOG.error(&quot;Unexpected exception&quot;,e);</span>
<span class="nc" id="L234">                    throw e;</span>
                } else {
<span class="fc" id="L236">                    LOG.warn(&quot;Unexpected exception, tries=&quot;+tries+</span>
                            &quot;, connecting to &quot; + addr,e);
<span class="fc" id="L238">                    sock = new Socket();</span>
<span class="fc" id="L239">                    sock.setSoTimeout(self.tickTime * self.initLimit);</span>
                }
            }
<span class="fc" id="L242">            Thread.sleep(1000);</span>
        }
<span class="fc" id="L244">        leaderIs = BinaryInputArchive.getArchive(new BufferedInputStream(</span>
<span class="fc" id="L245">                sock.getInputStream()));</span>
<span class="fc" id="L246">        bufferedOutput = new BufferedOutputStream(sock.getOutputStream());</span>
<span class="fc" id="L247">        leaderOs = BinaryOutputArchive.getArchive(bufferedOutput);</span>
<span class="fc" id="L248">    }   </span>
    
    /**
     * Once connected to the leader, perform the handshake protocol to
     * establish a following / observing connection. 
     * @param pktType
     * @return the zxid the Leader sends for synchronization purposes.
     * @throws IOException
     */
    protected long registerWithLeader(int pktType) throws IOException{
        /*
         * Send follower info, including last zxid and sid
         */
<span class="fc" id="L261">    	long lastLoggedZxid = self.getLastLoggedZxid();</span>
<span class="fc" id="L262">        QuorumPacket qp = new QuorumPacket();                </span>
<span class="fc" id="L263">        qp.setType(pktType);</span>
<span class="fc" id="L264">        qp.setZxid(ZxidUtils.makeZxid(self.getAcceptedEpoch(), 0));</span>
        
        /*
         * Add sid to payload
         */
<span class="fc" id="L269">        LearnerInfo li = new LearnerInfo(self.getId(), 0x10000);</span>
<span class="fc" id="L270">        ByteArrayOutputStream bsid = new ByteArrayOutputStream();</span>
<span class="fc" id="L271">        BinaryOutputArchive boa = BinaryOutputArchive.getArchive(bsid);</span>
<span class="fc" id="L272">        boa.writeRecord(li, &quot;LearnerInfo&quot;);</span>
<span class="fc" id="L273">        qp.setData(bsid.toByteArray());</span>
        
<span class="fc" id="L275">        writePacket(qp, true);</span>
<span class="fc" id="L276">        readPacket(qp);        </span>
<span class="fc" id="L277">        final long newEpoch = ZxidUtils.getEpochFromZxid(qp.getZxid());</span>
<span class="pc bpc" id="L278" title="1 of 2 branches missed.">		if (qp.getType() == Leader.LEADERINFO) {</span>
        	// we are connected to a 1.0 server so accept the new epoch and read the next packet
<span class="fc" id="L280">        	leaderProtocolVersion = ByteBuffer.wrap(qp.getData()).getInt();</span>
<span class="fc" id="L281">        	byte epochBytes[] = new byte[4];</span>
<span class="fc" id="L282">        	final ByteBuffer wrappedEpochBytes = ByteBuffer.wrap(epochBytes);</span>
<span class="fc bfc" id="L283" title="All 2 branches covered.">        	if (newEpoch &gt; self.getAcceptedEpoch()) {</span>
<span class="fc" id="L284">        		wrappedEpochBytes.putInt((int)self.getCurrentEpoch());</span>
<span class="fc" id="L285">        		self.setAcceptedEpoch(newEpoch);</span>
<span class="fc bfc" id="L286" title="All 2 branches covered.">        	} else if (newEpoch == self.getAcceptedEpoch()) {</span>
        		// since we have already acked an epoch equal to the leaders, we cannot ack
        		// again, but we still need to send our lastZxid to the leader so that we can
        		// sync with it if it does assume leadership of the epoch.
        		// the -1 indicates that this reply should not count as an ack for the new epoch
<span class="fc" id="L291">                wrappedEpochBytes.putInt(-1);</span>
        	} else {
<span class="fc" id="L293">        		throw new IOException(&quot;Leaders epoch, &quot; + newEpoch + &quot; is less than accepted epoch, &quot; + self.getAcceptedEpoch());</span>
        	}
<span class="fc" id="L295">        	QuorumPacket ackNewEpoch = new QuorumPacket(Leader.ACKEPOCH, lastLoggedZxid, epochBytes, null);</span>
<span class="fc" id="L296">        	writePacket(ackNewEpoch, true);</span>
<span class="fc" id="L297">            return ZxidUtils.makeZxid(newEpoch, 0);</span>
        } else {
<span class="nc bnc" id="L299" title="All 2 branches missed.">        	if (newEpoch &gt; self.getAcceptedEpoch()) {</span>
<span class="nc" id="L300">        		self.setAcceptedEpoch(newEpoch);</span>
        	}
<span class="nc bnc" id="L302" title="All 2 branches missed.">            if (qp.getType() != Leader.NEWLEADER) {</span>
<span class="nc" id="L303">                LOG.error(&quot;First packet should have been NEWLEADER&quot;);</span>
<span class="nc" id="L304">                throw new IOException(&quot;First packet should have been NEWLEADER&quot;);</span>
            }
<span class="nc" id="L306">            return qp.getZxid();</span>
        }
    } 
    
    /**
     * Finally, synchronize our history with the Leader. 
     * @param newLeaderZxid
     * @throws IOException
     * @throws InterruptedException
     */
    protected void syncWithLeader(long newLeaderZxid) throws IOException, InterruptedException{
<span class="fc" id="L317">        QuorumPacket ack = new QuorumPacket(Leader.ACK, 0, null, null);</span>
<span class="fc" id="L318">        QuorumPacket qp = new QuorumPacket();</span>
<span class="fc" id="L319">        long newEpoch = ZxidUtils.getEpochFromZxid(newLeaderZxid);</span>
        
<span class="fc" id="L321">        readPacket(qp);   </span>
<span class="fc" id="L322">        LinkedList&lt;Long&gt; packetsCommitted = new LinkedList&lt;Long&gt;();</span>
<span class="fc" id="L323">        LinkedList&lt;PacketInFlight&gt; packetsNotCommitted = new LinkedList&lt;PacketInFlight&gt;();</span>
<span class="fc" id="L324">        synchronized (zk) {</span>
<span class="fc bfc" id="L325" title="All 2 branches covered.">            if (qp.getType() == Leader.DIFF) {</span>
<span class="fc" id="L326">                LOG.info(&quot;Getting a diff from the leader 0x&quot; + Long.toHexString(qp.getZxid()));                </span>
            }
<span class="fc bfc" id="L328" title="All 2 branches covered.">            else if (qp.getType() == Leader.SNAP) {</span>
<span class="fc" id="L329">                LOG.info(&quot;Getting a snapshot from leader&quot;);</span>
                // The leader is going to dump the database
                // clear our own database and read
<span class="fc" id="L332">                zk.getZKDatabase().clear();</span>
<span class="fc" id="L333">                zk.getZKDatabase().deserializeSnapshot(leaderIs);</span>
<span class="fc" id="L334">                String signature = leaderIs.readString(&quot;signature&quot;);</span>
<span class="pc bpc" id="L335" title="1 of 2 branches missed.">                if (!signature.equals(&quot;BenWasHere&quot;)) {</span>
<span class="nc" id="L336">                    LOG.error(&quot;Missing signature. Got &quot; + signature);</span>
<span class="nc" id="L337">                    throw new IOException(&quot;Missing signature&quot;);                   </span>
                }
<span class="pc bpc" id="L339" title="1 of 2 branches missed.">            } else if (qp.getType() == Leader.TRUNC) {</span>
                //we need to truncate the log to the lastzxid of the leader
<span class="fc" id="L341">                LOG.warn(&quot;Truncating log to get in sync with the leader 0x&quot;</span>
<span class="fc" id="L342">                        + Long.toHexString(qp.getZxid()));</span>
<span class="fc" id="L343">                boolean truncated=zk.getZKDatabase().truncateLog(qp.getZxid());</span>
<span class="pc bpc" id="L344" title="1 of 2 branches missed.">                if (!truncated) {</span>
                    // not able to truncate the log
<span class="nc" id="L346">                    LOG.error(&quot;Not able to truncate the log &quot;</span>
<span class="nc" id="L347">                            + Long.toHexString(qp.getZxid()));</span>
<span class="nc" id="L348">                    System.exit(13);</span>
                }

<span class="fc" id="L351">            }</span>
            else {
<span class="nc" id="L353">                LOG.error(&quot;Got unexpected packet from leader &quot;</span>
<span class="nc" id="L354">                        + qp.getType() + &quot; exiting ... &quot; );</span>
<span class="nc" id="L355">                System.exit(13);</span>

            }
<span class="fc" id="L358">            zk.getZKDatabase().setlastProcessedZxid(qp.getZxid());</span>
<span class="fc" id="L359">            zk.createSessionTracker();            </span>
            
<span class="fc" id="L361">            long lastQueued = 0;</span>

            // in V1.0 we take a snapshot when we get the NEWLEADER message, but in pre V1.0
            // we take the snapshot at the UPDATE, since V1.0 also gets the UPDATE (after the NEWLEADER)
            // we need to make sure that we don't take the snapshot twice.
<span class="fc" id="L366">            boolean snapshotTaken = false;</span>
            // we are now going to start getting transactions to apply followed by an UPTODATE
            outerLoop:
<span class="pc bpc" id="L369" title="1 of 2 branches missed.">            while (self.isRunning()) {</span>
<span class="fc" id="L370">                readPacket(qp);</span>
<span class="fc bfc" id="L371" title="All 6 branches covered.">                switch(qp.getType()) {</span>
                case Leader.PROPOSAL:
<span class="fc" id="L373">                    PacketInFlight pif = new PacketInFlight();</span>
<span class="fc" id="L374">                    pif.hdr = new TxnHeader();</span>
<span class="fc" id="L375">                    pif.rec = SerializeUtils.deserializeTxn(qp.getData(), pif.hdr);</span>
<span class="fc bfc" id="L376" title="All 2 branches covered.">                    if (pif.hdr.getZxid() != lastQueued + 1) {</span>
<span class="fc" id="L377">                    LOG.warn(&quot;Got zxid 0x&quot;</span>
<span class="fc" id="L378">                            + Long.toHexString(pif.hdr.getZxid())</span>
                            + &quot; expected 0x&quot;
<span class="fc" id="L380">                            + Long.toHexString(lastQueued + 1));</span>
                    }
<span class="fc" id="L382">                    lastQueued = pif.hdr.getZxid();</span>
<span class="fc" id="L383">                    packetsNotCommitted.add(pif);</span>
<span class="fc" id="L384">                    break;</span>
                case Leader.COMMIT:
<span class="fc bfc" id="L386" title="All 2 branches covered.">                    if (!snapshotTaken) {</span>
<span class="fc" id="L387">                        pif = packetsNotCommitted.peekFirst();</span>
<span class="pc bpc" id="L388" title="1 of 2 branches missed.">                        if (pif.hdr.getZxid() != qp.getZxid()) {</span>
<span class="nc" id="L389">                            LOG.warn(&quot;Committing &quot; + qp.getZxid() + &quot;, but next proposal is &quot; + pif.hdr.getZxid());</span>
                        } else {
<span class="fc" id="L391">                            zk.processTxn(pif.hdr, pif.rec);</span>
<span class="fc" id="L392">                            packetsNotCommitted.remove();</span>
                        }
                    } else {
<span class="fc" id="L395">                        packetsCommitted.add(qp.getZxid());</span>
                    }
<span class="fc" id="L397">                    break;</span>
                case Leader.INFORM:
                    /*
                     * Only observer get this type of packet. We treat this
                     * as receiving PROPOSAL and COMMMIT.
                     */
<span class="fc" id="L403">                    PacketInFlight packet = new PacketInFlight();</span>
<span class="fc" id="L404">                    packet.hdr = new TxnHeader();</span>
<span class="fc" id="L405">                    packet.rec = SerializeUtils.deserializeTxn(qp.getData(), packet.hdr);</span>
                    // Log warning message if txn comes out-of-order
<span class="pc bpc" id="L407" title="1 of 2 branches missed.">                    if (packet.hdr.getZxid() != lastQueued + 1) {</span>
<span class="nc" id="L408">                        LOG.warn(&quot;Got zxid 0x&quot;</span>
<span class="nc" id="L409">                                + Long.toHexString(packet.hdr.getZxid())</span>
                                + &quot; expected 0x&quot;
<span class="nc" id="L411">                                + Long.toHexString(lastQueued + 1));</span>
                    }
<span class="fc" id="L413">                    lastQueued = packet.hdr.getZxid();</span>
<span class="pc bpc" id="L414" title="1 of 2 branches missed.">                    if (!snapshotTaken) {</span>
                        // Apply to db directly if we haven't taken the snapshot
<span class="nc" id="L416">                        zk.processTxn(packet.hdr, packet.rec);</span>
                    } else {
<span class="fc" id="L418">                        packetsNotCommitted.add(packet);</span>
<span class="fc" id="L419">                        packetsCommitted.add(qp.getZxid());</span>
                    }
<span class="fc" id="L421">                    break;</span>
                case Leader.UPTODATE:
<span class="pc bpc" id="L423" title="1 of 2 branches missed.">                    if (!snapshotTaken) { // true for the pre v1.0 case</span>
<span class="nc" id="L424">                        zk.takeSnapshot();</span>
<span class="nc" id="L425">                        self.setCurrentEpoch(newEpoch);</span>
                    }
<span class="fc" id="L427">                    self.cnxnFactory.setZooKeeperServer(zk);                </span>
<span class="fc" id="L428">                    break outerLoop;</span>
                case Leader.NEWLEADER: // it will be NEWLEADER in v1.0
                    // Create updatingEpoch file and remove it after current
                    // epoch is set. QuorumPeer.loadDataBase() uses this file to
                    // detect the case where the server was terminated after
                    // taking a snapshot but before setting the current epoch.
<span class="fc" id="L434">                    File updating = new File(self.getTxnFactory().getSnapDir(),</span>
                                        QuorumPeer.UPDATING_EPOCH_FILENAME);
<span class="pc bpc" id="L436" title="2 of 4 branches missed.">                    if (!updating.exists() &amp;&amp; !updating.createNewFile()) {</span>
<span class="nc" id="L437">                        throw new IOException(&quot;Failed to create &quot; +</span>
<span class="nc" id="L438">                                              updating.toString());</span>
                    }
<span class="fc" id="L440">                    zk.takeSnapshot();</span>
<span class="fc" id="L441">                    self.setCurrentEpoch(newEpoch);</span>
<span class="pc bpc" id="L442" title="1 of 2 branches missed.">                    if (!updating.delete()) {</span>
<span class="nc" id="L443">                        throw new IOException(&quot;Failed to delete &quot; +</span>
<span class="nc" id="L444">                                              updating.toString());</span>
                    }
<span class="fc" id="L446">                    snapshotTaken = true;</span>
<span class="fc" id="L447">                    writePacket(new QuorumPacket(Leader.ACK, newLeaderZxid, null, null), true);</span>
<span class="fc" id="L448">                    break;</span>
                }
            }
<span class="fc" id="L451">        }</span>
<span class="fc" id="L452">        ack.setZxid(ZxidUtils.makeZxid(newEpoch, 0));</span>
<span class="fc" id="L453">        writePacket(ack, true);</span>
<span class="fc" id="L454">        sock.setSoTimeout(self.tickTime * self.syncLimit);</span>
<span class="fc" id="L455">        zk.startup();</span>
        /*
         * Update the election vote here to ensure that all members of the
         * ensemble report the same vote to new servers that start up and
         * send leader election notifications to the ensemble.
         * 
         * @see https://issues.apache.org/jira/browse/ZOOKEEPER-1732
         */
<span class="fc" id="L463">        self.updateElectionVote(newEpoch);</span>

        // We need to log the stuff that came in between the snapshot and the uptodate
<span class="fc bfc" id="L466" title="All 2 branches covered.">        if (zk instanceof FollowerZooKeeperServer) {</span>
<span class="fc" id="L467">            FollowerZooKeeperServer fzk = (FollowerZooKeeperServer)zk;</span>
<span class="fc bfc" id="L468" title="All 2 branches covered.">            for(PacketInFlight p: packetsNotCommitted) {</span>
<span class="fc" id="L469">                fzk.logRequest(p.hdr, p.rec);</span>
<span class="fc" id="L470">            }</span>
<span class="fc bfc" id="L471" title="All 2 branches covered.">            for(Long zxid: packetsCommitted) {</span>
<span class="fc" id="L472">                fzk.commit(zxid);</span>
<span class="fc" id="L473">            }</span>
<span class="pc bpc" id="L474" title="1 of 2 branches missed.">        } else if (zk instanceof ObserverZooKeeperServer) {</span>
            // Similar to follower, we need to log requests between the snapshot
            // and UPTODATE
<span class="fc" id="L477">            ObserverZooKeeperServer ozk = (ObserverZooKeeperServer) zk;</span>
<span class="fc bfc" id="L478" title="All 2 branches covered.">            for (PacketInFlight p : packetsNotCommitted) {</span>
<span class="fc" id="L479">                Long zxid = packetsCommitted.peekFirst();</span>
<span class="pc bpc" id="L480" title="1 of 2 branches missed.">                if (p.hdr.getZxid() != zxid) {</span>
                    // log warning message if there is no matching commit
                    // old leader send outstanding proposal to observer
<span class="nc" id="L483">                    LOG.warn(&quot;Committing &quot; + Long.toHexString(zxid)</span>
                            + &quot;, but next proposal is &quot;
<span class="nc" id="L485">                            + Long.toHexString(p.hdr.getZxid()));</span>
<span class="nc" id="L486">                    continue;</span>
                }
<span class="fc" id="L488">                packetsCommitted.remove();</span>
<span class="fc" id="L489">                Request request = new Request(null, p.hdr.getClientId(),</span>
<span class="fc" id="L490">                        p.hdr.getCxid(), p.hdr.getType(), null, null);</span>
<span class="fc" id="L491">                request.txn = p.rec;</span>
<span class="fc" id="L492">                request.hdr = p.hdr;</span>
<span class="fc" id="L493">                ozk.commitRequest(request);</span>
<span class="fc" id="L494">            }</span>
<span class="fc" id="L495">        } else {</span>
            // New server type need to handle in-flight packets
<span class="nc" id="L497">            throw new UnsupportedOperationException(&quot;Unknown server type&quot;);</span>
        }
<span class="fc" id="L499">    }</span>
    
    protected void revalidate(QuorumPacket qp) throws IOException {
<span class="fc" id="L502">        ByteArrayInputStream bis = new ByteArrayInputStream(qp</span>
<span class="fc" id="L503">                .getData());</span>
<span class="fc" id="L504">        DataInputStream dis = new DataInputStream(bis);</span>
<span class="fc" id="L505">        long sessionId = dis.readLong();</span>
<span class="fc" id="L506">        boolean valid = dis.readBoolean();</span>
<span class="fc" id="L507">        ServerCnxn cnxn = pendingRevalidations</span>
<span class="fc" id="L508">        .remove(sessionId);</span>
<span class="pc bpc" id="L509" title="1 of 2 branches missed.">        if (cnxn == null) {</span>
<span class="nc" id="L510">            LOG.warn(&quot;Missing session 0x&quot;</span>
<span class="nc" id="L511">                    + Long.toHexString(sessionId)</span>
                    + &quot; for validation&quot;);
        } else {
<span class="fc" id="L514">            zk.finishSessionInit(cnxn, valid);</span>
        }
<span class="pc bpc" id="L516" title="1 of 2 branches missed.">        if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L517">            ZooTrace.logTraceMessage(LOG,</span>
                    ZooTrace.SESSION_TRACE_MASK,
<span class="nc" id="L519">                    &quot;Session 0x&quot; + Long.toHexString(sessionId)</span>
                    + &quot; is valid: &quot; + valid);
        }
<span class="fc" id="L522">    }</span>
        
    protected void ping(QuorumPacket qp) throws IOException {
        // Send back the ping with our session data
<span class="fc" id="L526">        ByteArrayOutputStream bos = new ByteArrayOutputStream();</span>
<span class="fc" id="L527">        DataOutputStream dos = new DataOutputStream(bos);</span>
<span class="fc" id="L528">        HashMap&lt;Long, Integer&gt; touchTable = zk</span>
<span class="fc" id="L529">                .getTouchSnapshot();</span>
<span class="fc bfc" id="L530" title="All 2 branches covered.">        for (Entry&lt;Long, Integer&gt; entry : touchTable.entrySet()) {</span>
<span class="fc" id="L531">            dos.writeLong(entry.getKey());</span>
<span class="fc" id="L532">            dos.writeInt(entry.getValue());</span>
<span class="fc" id="L533">        }</span>
<span class="fc" id="L534">        qp.setData(bos.toByteArray());</span>
<span class="fc" id="L535">        writePacket(qp, true);</span>
<span class="fc" id="L536">    }</span>
    
    
    /**
     * Shutdown the Peer
     */
    public void shutdown() {
        // set the zookeeper server to null
<span class="fc" id="L544">        self.cnxnFactory.setZooKeeperServer(null);</span>
        // clear all the connections
<span class="fc" id="L546">        self.cnxnFactory.closeAll();</span>
        // shutdown previous zookeeper
<span class="pc bpc" id="L548" title="1 of 2 branches missed.">        if (zk != null) {</span>
<span class="fc" id="L549">            zk.shutdown();</span>
        }
<span class="fc" id="L551">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>